using System;
using System.Collections.Generic;
using System.Text;

namespace Bagrut
{
    /// <summary>
    /// tzxeo ly`ld 4 aabxez wiu zyq"f
    /// </summary>
    /// <author> veez dtizeg, d`epi' draxiz ixeylim </author>
    /// <version> 17/5/2007 </version>
    public class IncomingCallsDiary
    {
        private List<string> incomingCalls;
        private int maxCalls;
        private int currentCalls;

        public void AddIncomingCall(string tel)
        {
            bool telWasAlreadyInDiary = false;
            Node<string> prev = null;
            Node<string> curr = this.incomingCalls.GetFirst();
            while (curr != null)
            {
                if (curr.GetInfo().Equals(tel))
                {
                    this.incomingCalls.Remove(curr);
                    telWasAlreadyInDiary = true;
                }
                prev = curr;
                curr = curr.GetNext();
            }
            if (!telWasAlreadyInDiary)
            {
                if (this.currentCalls < this.maxCalls)
                    this.currentCalls++;
                else
                    this.incomingCalls.Remove(prev);
            }
            this.incomingCalls.Insert(null, tel);
        }
    }
}
